package de.hdm_stuttgart.mi.sda1.sql2catalog;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.jdom2.Element;

import de.hdm_stuttgart.mi.sda1.sql2catalog.model.Description;
import de.hdm_stuttgart.mi.sda1.sql2catalog.model.Product;

/**
 * Reading product data
 *
 */
public class RdbmsAccess {

	static final EntityManager em;

	static {
		final EntityManagerFactory emFactory =  Persistence.createEntityManagerFactory("none");
		em = emFactory.createEntityManager();
	}

	public void appendProducts(final Element root) {
		final EntityTransaction transaction = em.getTransaction();
        transaction.begin();

		for (final Product p: em.createQuery("SELECT p FROM Product p", Product.class).getResultList()) {

			final Element productElement = new Element("product");
			root.addContent(productElement);
			productElement.setAttribute("id", "" + p.getId());

			final Element nameElement = new Element("name");
			productElement.addContent(nameElement);
			nameElement.addContent(p.getName());

			addDescriptions(p.getDescriptions(), productElement);

			final Integer productAge = p.getAge();
			if (null != productAge) {
				final Element ageElement = new Element("age");
				productElement.addContent(ageElement);
				ageElement.addContent(productAge.toString());
			}
		}
		transaction.commit();
	}

	private void addDescriptions(final List<Description> descriptions, final Element productElement) {

		for(final Description d: descriptions) {
			final Element descriptionElement = new Element("description");
			productElement.addContent(descriptionElement);
			descriptionElement.addContent(d.getDescription());
		}
	}
}